{
  "openapi": "3.1.0",
  "info": {
    "title": "threefold API",
    "version": "0.2.0",
    "description": "Market-entry intelligence for apps across storefronts, languages, and channels."
  },
  "servers": [
    {
      "url": "https://api.threefold.eco",
      "description": "Production API"
    }
  ],
  "paths": {
    "/api/meta": {
      "get": {
        "operationId": "library_meta",
        "summary": "Library Metadata",
        "description": "Library overview - configured markets, niches, the first-cut profile and data counts",
        "tags": [
          "account"
        ],
        "parameters": [],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "generatedAt",
                    "markets",
                    "niches",
                    "libraryCut",
                    "counts",
                    "stores"
                  ],
                  "properties": {
                    "generatedAt": {
                      "type": "string",
                      "description": "When the newest data was collected, across all sources (ISO 8601). Per source in freshness."
                    },
                    "freshness": {
                      "type": "object",
                      "description": "Latest real collection time per source. snapshotAt is the seed snapshot's date.",
                      "properties": {
                        "latestAt": {
                          "type": [
                            "string",
                            "null"
                          ]
                        },
                        "snapshotAt": {
                          "type": [
                            "string",
                            "null"
                          ]
                        },
                        "sources": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "properties": {
                              "id": {
                                "type": "string"
                              },
                              "pillar": {
                                "type": "string"
                              },
                              "store": {
                                "type": [
                                  "string",
                                  "null"
                                ]
                              },
                              "label": {
                                "type": "string"
                              },
                              "collectedAt": {
                                "type": [
                                  "string",
                                  "null"
                                ]
                              }
                            }
                          }
                        }
                      }
                    },
                    "source": {
                      "type": "string"
                    },
                    "storage": {
                      "type": "string"
                    },
                    "markets": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "niches": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "appsPerNiche": {
                      "type": "integer"
                    },
                    "firstCut": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    },
                    "counts": {
                      "type": "object"
                    },
                    "stores": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/search": {
      "get": {
        "operationId": "search_apps",
        "summary": "Search Apps",
        "description": "Search apps already in the library by name or developer, with where each one charts",
        "tags": [
          "search"
        ],
        "parameters": [
          {
            "name": "q",
            "in": "query",
            "required": true,
            "description": "App name or developer",
            "schema": {
              "description": "App name or developer",
              "example": "duolingo",
              "type": "string"
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "description": "Page size",
            "schema": {
              "description": "Page size",
              "type": "integer"
            }
          },
          {
            "name": "offset",
            "in": "query",
            "required": false,
            "description": "Skip this many results",
            "schema": {
              "description": "Skip this many results",
              "type": "integer"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "required": [
                      "id",
                      "title",
                      "developer",
                      "store"
                    ],
                    "properties": {
                      "id": {
                        "type": [
                          "string",
                          "integer"
                        ]
                      },
                      "title": {
                        "type": "string"
                      },
                      "developer": {
                        "type": "string"
                      },
                      "icon": {
                        "type": [
                          "string",
                          "null"
                        ]
                      },
                      "rating": {
                        "type": [
                          "number",
                          "null"
                        ]
                      },
                      "ratingCount": {
                        "type": [
                          "integer",
                          "null"
                        ]
                      },
                      "market": {
                        "type": [
                          "string",
                          "null"
                        ]
                      },
                      "signals": {
                        "type": "object"
                      },
                      "charts": {
                        "type": "array"
                      },
                      "store": {
                        "type": "string"
                      },
                      "stores": {
                        "type": "array"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/store-search": {
      "get": {
        "operationId": "search_store",
        "summary": "Search App Store",
        "description": "Live App Store search for any app, not only charting ones, to get its id",
        "tags": [
          "search"
        ],
        "parameters": [
          {
            "name": "q",
            "in": "query",
            "required": true,
            "description": "Search term",
            "schema": {
              "description": "Search term",
              "example": "headspace",
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "required": [
                      "id",
                      "title",
                      "developer",
                      "inDataset"
                    ],
                    "properties": {
                      "id": {
                        "type": [
                          "string",
                          "integer"
                        ]
                      },
                      "title": {
                        "type": "string"
                      },
                      "developer": {
                        "type": "string"
                      },
                      "icon": {
                        "type": [
                          "string",
                          "null"
                        ]
                      },
                      "inDataset": {
                        "type": "boolean"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/chart": {
      "get": {
        "operationId": "top_apps",
        "summary": "Top Apps",
        "description": "Top free, paid or grossing apps in one market and niche or genre, with localisation signals and the market profile",
        "tags": [
          "chart"
        ],
        "parameters": [
          {
            "name": "market",
            "in": "query",
            "required": true,
            "schema": {
              "example": "jp",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": true,
            "description": "Niche or any collected genre slug (GET /api/meta genres)",
            "schema": {
              "description": "Niche or any collected genre slug (GET /api/meta genres)",
              "example": "health-fitness",
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle",
                "business",
                "weather",
                "utilities",
                "travel",
                "sports",
                "social-networking",
                "reference",
                "photo-video",
                "news",
                "navigation",
                "music",
                "entertainment",
                "books",
                "medical",
                "magazines-newspapers",
                "catalogs",
                "food-drink",
                "shopping",
                "stickers",
                "developer-tools",
                "graphics-design",
                "games-action",
                "games-adventure",
                "games-casual",
                "games-board",
                "games-card",
                "games-casino",
                "games-dice",
                "games-educational",
                "games-family",
                "games-music",
                "games-puzzle",
                "games-racing",
                "games-role-playing",
                "games-simulation",
                "games-sports",
                "games-strategy",
                "games-trivia",
                "games-word",
                "games-arcade",
                "communication",
                "dating",
                "video-players",
                "personalization",
                "auto-vehicles",
                "beauty",
                "comics",
                "events",
                "house-home",
                "parenting"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "chart",
            "in": "query",
            "required": false,
            "description": "Chart type: top free (default), top paid or top grossing",
            "schema": {
              "description": "Chart type: top free (default), top paid or top grossing",
              "type": "string",
              "enum": [
                "free",
                "paid",
                "grossing"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "market",
                    "niche",
                    "apps",
                    "store"
                  ],
                  "properties": {
                    "market": {
                      "type": [
                        "string",
                        "object"
                      ]
                    },
                    "niche": {
                      "type": [
                        "string",
                        "object"
                      ]
                    },
                    "library": {
                      "type": "object"
                    },
                    "apps": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "store": {
                      "type": "string"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/compare": {
      "get": {
        "operationId": "compare_markets",
        "summary": "Compare Markets",
        "description": "Compare one niche in two markets - shared winners, apps that have not crossed over, local-only winners",
        "tags": [
          "compare"
        ],
        "parameters": [
          {
            "name": "from",
            "in": "query",
            "required": true,
            "description": "Home market",
            "schema": {
              "description": "Home market",
              "example": "us",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "to",
            "in": "query",
            "required": true,
            "description": "Target market",
            "schema": {
              "description": "Target market",
              "example": "de",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": true,
            "description": "Niche or any collected genre slug (GET /api/meta genres)",
            "schema": {
              "description": "Niche or any collected genre slug (GET /api/meta genres)",
              "example": "health-fitness",
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle",
                "business",
                "weather",
                "utilities",
                "travel",
                "sports",
                "social-networking",
                "reference",
                "photo-video",
                "news",
                "navigation",
                "music",
                "entertainment",
                "books",
                "medical",
                "magazines-newspapers",
                "catalogs",
                "food-drink",
                "shopping",
                "stickers",
                "developer-tools",
                "graphics-design",
                "games-action",
                "games-adventure",
                "games-casual",
                "games-board",
                "games-card",
                "games-casino",
                "games-dice",
                "games-educational",
                "games-family",
                "games-music",
                "games-puzzle",
                "games-racing",
                "games-role-playing",
                "games-simulation",
                "games-sports",
                "games-strategy",
                "games-trivia",
                "games-word",
                "games-arcade",
                "communication",
                "dating",
                "video-players",
                "personalization",
                "auto-vehicles",
                "beauty",
                "comics",
                "events",
                "house-home",
                "parenting"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "chart",
            "in": "query",
            "required": false,
            "description": "Chart type: top free (default), top paid or top grossing",
            "schema": {
              "description": "Chart type: top free (default), top paid or top grossing",
              "type": "string",
              "enum": [
                "free",
                "paid",
                "grossing"
              ]
            }
          },
          {
            "name": "include_images",
            "in": "query",
            "required": false,
            "description": "Fetch and return low-res preview images (default false)",
            "schema": {
              "description": "Fetch and return low-res preview images (default false)",
              "type": "boolean"
            }
          },
          {
            "name": "image_format",
            "in": "query",
            "required": false,
            "description": "Preview image format (webp default, or jpg)",
            "schema": {
              "description": "Preview image format (webp default, or jpg)",
              "type": "string",
              "enum": [
                "webp",
                "jpg"
              ]
            }
          },
          {
            "name": "task_intent",
            "in": "query",
            "required": false,
            "description": "Caller task intent or context, used to shape output and logged (hashed)",
            "schema": {
              "description": "Caller task intent or context, used to shape output and logged (hashed)",
              "type": "string"
            }
          },
          {
            "name": "output_destination",
            "in": "query",
            "required": false,
            "description": "Target environment: code (compact JSON), doc (citations and links), chat (summary sentence), design_tool (visual assets and layout)",
            "schema": {
              "description": "Target environment: code (compact JSON), doc (citations and links), chat (summary sentence), design_tool (visual assets and layout)",
              "type": "string",
              "enum": [
                "code",
                "doc",
                "chat",
                "design_tool"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "from",
                    "to",
                    "shared",
                    "notCrossed",
                    "localOnly",
                    "store"
                  ],
                  "properties": {
                    "from": {
                      "type": [
                        "string",
                        "object",
                        "array"
                      ]
                    },
                    "to": {
                      "type": [
                        "string",
                        "object",
                        "array"
                      ]
                    },
                    "niche": {
                      "type": [
                        "string",
                        "null"
                      ]
                    },
                    "shared": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "notCrossed": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "localOnly": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "library": {
                      "type": "object"
                    },
                    "store": {
                      "type": "string"
                    },
                    "summary": {
                      "type": "string"
                    },
                    "citations": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}": {
      "get": {
        "operationId": "get_app",
        "summary": "Get App",
        "description": "One app across storefronts - localised title, copy language, screenshots, ratings and signals per market",
        "tags": [
          "app"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "App Store id, or play:<package> for Play-only apps",
            "schema": {
              "description": "App Store id, or play:<package> for Play-only apps",
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "markets",
            "in": "query",
            "required": false,
            "description": "Comma-separated market codes. Defaults to every market.",
            "schema": {
              "description": "Comma-separated market codes. Defaults to every market.",
              "type": "array",
              "items": {
                "type": "string",
                "enum": [
                  "gb",
                  "us",
                  "es",
                  "mx",
                  "ar",
                  "br",
                  "de",
                  "fr",
                  "jp",
                  "kr",
                  "ca",
                  "au",
                  "tw",
                  "it",
                  "nl",
                  "tr",
                  "sa",
                  "in",
                  "ca-fr",
                  "hk",
                  "th",
                  "id",
                  "ch",
                  "pl",
                  "se",
                  "ae",
                  "vn",
                  "ph",
                  "pt",
                  "at",
                  "co",
                  "cl"
                ]
              }
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "include_images",
            "in": "query",
            "required": false,
            "description": "Fetch and return low-res preview images (default false)",
            "schema": {
              "description": "Fetch and return low-res preview images (default false)",
              "type": "boolean"
            }
          },
          {
            "name": "image_format",
            "in": "query",
            "required": false,
            "description": "Preview image format (webp default, or jpg)",
            "schema": {
              "description": "Preview image format (webp default, or jpg)",
              "type": "string",
              "enum": [
                "webp",
                "jpg"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "id",
                    "title",
                    "developer",
                    "storefronts"
                  ],
                  "properties": {
                    "id": {
                      "type": "string"
                    },
                    "title": {
                      "type": "string"
                    },
                    "developer": {
                      "type": "string"
                    },
                    "genre": {
                      "type": [
                        "string",
                        "null"
                      ]
                    },
                    "icon": {
                      "type": [
                        "string",
                        "null"
                      ]
                    },
                    "charts": {
                      "type": "array"
                    },
                    "tracking": {
                      "type": [
                        "object",
                        "null"
                      ]
                    },
                    "storefronts": {
                      "type": [
                        "object",
                        "array"
                      ]
                    },
                    "store": {
                      "type": "string"
                    },
                    "stores": {
                      "type": "array"
                    },
                    "play": {
                      "type": [
                        "object",
                        "null"
                      ]
                    },
                    "backfill": {
                      "type": "object"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}/brief": {
      "get": {
        "operationId": "market_brief",
        "summary": "Market Brief",
        "description": "Rules-based market-entry brief for moving one app into one market across Brand, Paid and Organic",
        "tags": [
          "brief"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Path parameter id",
            "schema": {
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "to",
            "in": "query",
            "required": true,
            "description": "Target market",
            "schema": {
              "description": "Target market",
              "example": "de",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "from",
            "in": "query",
            "required": false,
            "description": "Home market",
            "schema": {
              "description": "Home market",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "task_intent",
            "in": "query",
            "required": false,
            "description": "Caller task intent or context, used to shape output and logged (hashed)",
            "schema": {
              "description": "Caller task intent or context, used to shape output and logged (hashed)",
              "type": "string"
            }
          },
          {
            "name": "output_destination",
            "in": "query",
            "required": false,
            "description": "Target environment: code (compact JSON), doc (citations and links), chat (summary sentence), design_tool (visual assets and layout)",
            "schema": {
              "description": "Target environment: code (compact JSON), doc (citations and links), chat (summary sentence), design_tool (visual assets and layout)",
              "type": "string",
              "enum": [
                "code",
                "doc",
                "chat",
                "design_tool"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "app",
                    "to",
                    "pillars"
                  ],
                  "properties": {
                    "app": {
                      "type": "object"
                    },
                    "from": {
                      "type": [
                        "string",
                        "object",
                        "null"
                      ]
                    },
                    "to": {
                      "type": [
                        "string",
                        "object"
                      ]
                    },
                    "niche": {
                      "type": [
                        "string",
                        "object",
                        "null"
                      ]
                    },
                    "pillars": {
                      "type": "object"
                    },
                    "competitors": {
                      "type": "array"
                    },
                    "benchmarks": {
                      "type": [
                        "array",
                        "object"
                      ]
                    },
                    "library": {
                      "type": "object"
                    },
                    "store": {
                      "type": "string"
                    },
                    "summary": {
                      "type": "string"
                    },
                    "citations": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}/history": {
      "get": {
        "operationId": "listing_history",
        "summary": "Listing History",
        "description": "History of an app's store listing - title, description, screenshots and price changes over time",
        "tags": [
          "history"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Path parameter id",
            "schema": {
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "items"
                  ],
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "items": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "backfill": {
                      "type": "object"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/chart-history": {
      "get": {
        "operationId": "chart_history",
        "summary": "Chart History",
        "description": "Daily chart rank history for an app or a market and niche",
        "tags": [
          "history"
        ],
        "parameters": [
          {
            "name": "app",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": false,
            "description": "Niche or any collected genre slug (GET /api/meta genres)",
            "schema": {
              "description": "Niche or any collected genre slug (GET /api/meta genres)",
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle",
                "business",
                "weather",
                "utilities",
                "travel",
                "sports",
                "social-networking",
                "reference",
                "photo-video",
                "news",
                "navigation",
                "music",
                "entertainment",
                "books",
                "medical",
                "magazines-newspapers",
                "catalogs",
                "food-drink",
                "shopping",
                "stickers",
                "developer-tools",
                "graphics-design",
                "games-action",
                "games-adventure",
                "games-casual",
                "games-board",
                "games-card",
                "games-casino",
                "games-dice",
                "games-educational",
                "games-family",
                "games-music",
                "games-puzzle",
                "games-racing",
                "games-role-playing",
                "games-simulation",
                "games-sports",
                "games-strategy",
                "games-trivia",
                "games-word",
                "games-arcade",
                "communication",
                "dating",
                "video-players",
                "personalization",
                "auto-vehicles",
                "beauty",
                "comics",
                "events",
                "house-home",
                "parenting"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "chart",
            "in": "query",
            "required": false,
            "description": "Chart type: top free (default), top paid or top grossing",
            "schema": {
              "description": "Chart type: top free (default), top paid or top grossing",
              "type": "string",
              "enum": [
                "free",
                "paid",
                "grossing"
              ]
            }
          },
          {
            "name": "days",
            "in": "query",
            "required": false,
            "description": "Look-back window in days",
            "schema": {
              "description": "Look-back window in days",
              "default": 90,
              "type": "integer"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "offset",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "items"
                  ],
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "items": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}/reviews": {
      "get": {
        "operationId": "app_reviews",
        "summary": "App Reviews",
        "description": "Store reviews for an app in one market, with dates, ratings, version and language",
        "tags": [
          "reviews"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Path parameter id",
            "schema": {
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "store",
            "in": "query",
            "required": false,
            "description": "ios (default) or play",
            "schema": {
              "description": "ios (default) or play",
              "type": "string",
              "enum": [
                "ios",
                "play"
              ]
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "cursor",
            "in": "query",
            "required": false,
            "description": "Paging cursor from the previous response",
            "schema": {
              "description": "Paging cursor from the previous response",
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "items"
                  ],
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "items": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    },
                    "nextCursor": {
                      "type": [
                        "string",
                        "null"
                      ]
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}/reviews/summary": {
      "get": {
        "operationId": "review_summary",
        "summary": "Review Summary",
        "description": "Summary of an app's reviews in one market - rating mix, languages and recent themes",
        "tags": [
          "reviews"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Path parameter id",
            "schema": {
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "market",
            "in": "query",
            "required": true,
            "schema": {
              "example": "mx",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "appId",
                    "market",
                    "count"
                  ],
                  "properties": {
                    "appId": {
                      "type": "string"
                    },
                    "market": {
                      "type": "string"
                    },
                    "marketLanguage": {
                      "type": [
                        "string",
                        "null"
                      ]
                    },
                    "count": {
                      "type": "integer"
                    },
                    "avgRating": {
                      "type": [
                        "number",
                        "null"
                      ]
                    },
                    "ratingDistribution": {
                      "type": "object"
                    },
                    "languageShare": {
                      "type": "object"
                    },
                    "languages": {
                      "type": "object"
                    },
                    "byStore": {
                      "type": "array"
                    },
                    "replyRate": {
                      "type": [
                        "number",
                        "null"
                      ]
                    },
                    "window": {
                      "type": "object"
                    },
                    "reference": {
                      "type": "object"
                    },
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/paid": {
      "get": {
        "operationId": "paid_ads",
        "summary": "Paid Ads",
        "description": "Ads running in a market, for an app or a niche, with start and stop dates and how long they ran",
        "tags": [
          "paid"
        ],
        "parameters": [
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "app",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle"
              ]
            }
          },
          {
            "name": "source",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "meta_ad_library",
                "tiktok_creative_center",
                "tiktok_commercial_content",
                "google_ads_transparency",
                "linkedin_ad_library"
              ]
            }
          },
          {
            "name": "active",
            "in": "query",
            "required": false,
            "description": "Only ads still running",
            "schema": {
              "description": "Only ads still running",
              "type": "boolean"
            }
          },
          {
            "name": "minDays",
            "in": "query",
            "required": false,
            "description": "Ran at least this many days",
            "schema": {
              "description": "Ran at least this many days",
              "type": "integer"
            }
          },
          {
            "name": "lang",
            "in": "query",
            "required": false,
            "description": "Language (es) or variant (es-MX)",
            "schema": {
              "description": "Language (es) or variant (es-MX)",
              "type": "string"
            }
          },
          {
            "name": "sort",
            "in": "query",
            "required": false,
            "description": "longest (default) or recent",
            "schema": {
              "description": "longest (default) or recent",
              "type": "string",
              "enum": [
                "longest",
                "recent"
              ]
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "offset",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "items"
                  ],
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "items": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/paid/summary": {
      "get": {
        "operationId": "paid_summary",
        "summary": "Paid Summary",
        "description": "Summary of ads in a market - advertisers, counts and longest running ads",
        "tags": [
          "paid"
        ],
        "parameters": [
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "app",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "market": {
                      "type": "string"
                    },
                    "appId": {
                      "type": "string"
                    },
                    "niche": {
                      "type": "string"
                    },
                    "ads": {
                      "type": "integer"
                    },
                    "active": {
                      "type": "integer"
                    },
                    "longestRunningDays": {
                      "type": "integer"
                    },
                    "running60Plus": {
                      "type": "integer"
                    },
                    "videoShare": {
                      "type": [
                        "integer",
                        "null"
                      ]
                    },
                    "languages": {
                      "type": "object"
                    },
                    "sources": {
                      "type": "object"
                    },
                    "topAdvertisers": {
                      "type": "array"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/apps/{id}/paid-compare": {
      "get": {
        "operationId": "compare_paid",
        "summary": "Compare Paid",
        "description": "Compare one app's ads at home against a target market",
        "tags": [
          "compare"
        ],
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Path parameter id",
            "schema": {
              "example": "529479190",
              "type": "string"
            }
          },
          {
            "name": "to",
            "in": "query",
            "required": true,
            "schema": {
              "example": "de",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "from",
            "in": "query",
            "required": false,
            "description": "Home market",
            "schema": {
              "description": "Home market",
              "default": "us",
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "from": {
                      "type": "object"
                    },
                    "to": {
                      "type": "object"
                    },
                    "observations": {
                      "type": "array"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "401": {
            "description": "Missing or invalid authentication credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "402": {
            "description": "Insufficient balance or plan quota limit exceeded",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "403": {
            "description": "Forbidden - missing required scope or permissions",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "404": {
            "description": "Resource or endpoint not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded",
            "headers": {
              "Retry-After": {
                "description": "Seconds to wait before retrying",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          },
          "500": {
            "description": "Internal threefold server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Error"
                }
              }
            }
          }
        }
      }
    },
    "/api/organic": {
      "get": {
        "operationId": "organic_posts",
        "summary": "Organic Posts",
        "description": "Creator and social posts about an app or niche in a market, with publish dates and views",
        "tags": [
          "organic"
        ],
        "parameters": [
          {
            "name": "market",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "gb",
                "us",
                "es",
                "mx",
                "ar",
                "br",
                "de",
                "fr",
                "jp",
                "kr",
                "ca",
                "au",
                "tw",
                "it",
                "nl",
                "tr",
                "sa",
                "in",
                "ca-fr",
                "hk",
                "th",
                "id",
                "ch",
                "pl",
                "se",
                "ae",
                "vn",
                "ph",
                "pt",
                "at",
                "co",
                "cl"
              ]
            }
          },
          {
            "name": "app",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "niche",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "games",
                "education",
                "health-fitness",
                "finance",
                "productivity",
                "lifestyle"
              ]
            }
          },
          {
            "name": "source",
            "in": "query",
            "required": false,
            "description": "Channel: youtube, tiktok, instagram or x",
            "schema": {
              "description": "Channel: youtube, tiktok, instagram or x",
              "type": "string"
            }
          },
          {
            "name": "since",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "format": "date"
            }
          },
          {
            "name": "sort",
            "in": "query",
            "required": false,
            "description": "views (default) or recent",
            "schema": {
              "description": "views (default) or recent",
              "type": "string",
              "enum": [
                "views",
                "recent"
              ]
            }
          },
          {
            "name": "brand_account",
            "in": "query",
            "required": false,
            "description": "true: posts from the app's own account (Instagram Business Discovery); false: creator and hashtag posts. Omit for both.",
            "schema": {
              "description": "true: posts from the app's own account (Instagram Business Discovery); false: creator and hashtag posts. Omit for both.",
              "type": "boolean"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "offset",
            "in": "query",
            "required": false,
            "schema": {
              "type": "integer"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful response",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "items"
                  ],
                  "properties": {
                    "storage": {
                      "type": "string"
                    },
                    "note": {
                      "type": "string"
                    },
                    "items": {
                      "type": "array",
                      "items": {
                        "type": "object"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or malformed input",
            "content": {
              "application/json": {
[...]
